#!/usr/bin/perl -w -I.
#----------------------------------------------------------------------------\
# NetReg 2.0 (pre-release devel version)
#       DHCPD Registration Frontend
#
# Version 1.3: 
# Copyright (C) 1999-2002 Peter Valian, Southwestern University
# Version 2.0:
# Portions Copyright (C) 1999-2002 Peter Valian, Southwestern University.
# Portions Copyright (C) 2002 David Bussenschutt, Griffith University, Australia.
# Portions Copyright (C) 2002 Robert Lowe,  Lawrence University, Wisconsin.
# Portions Copyright (C) 2002-2003 Michael McMaster, Griffith University, Australia.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Version 1.3: http://www.netreg.org/
# Version 2.0: http://www.sourceforge.net/projects/netreg/
#
# Version 1.3 code contributions by:
#   Peter Valian <valianp@southwestern.edu>,  Southwestern University.
#     Author of Version 1.3rc2 
#   Bobby Clark <bobby.clark@eku.edu>, Eastern Kentucky University 
#     IMAP Authentication
#   Michael Grinnell <grinnell@american.edu>, American University
#     LDAP Authentication
#
# Version 2.0 code contributions by:
#   Robert Lowe <robert.h.lowe@lawrence.edu>, Lawrence University, Wisconsin.
#     CIDR (Subnet Masks etc) Handling/Notation
#     Alpha Testing, and bug chasing in David's Code.
#   David Bussenschutt <D.Bussenschutt@mailbox.gu.edu.au>, Griffith University, Queensland, Australia.
#     Much re-arrangement, and fixes, including but not limited to:
#     Perl 5 Syntax, and modules
#     File Locking
#     OMAPI Support
#     Remote dhcpdmanager daemon, and client support (functionally similar to omapi, but more fully implemented)
#     Improved Error Handling
#     Use of -w for improved code
#     LDAP group handling, for Permissions.
#     install_script
#   Michael McMaster <m4k3r@users.sourceforge.net>, Griffith University,  Queensland, Australia.
#     DBI/Oracle Support
#     HTML extraction/templating
#     Permissions handling (access controls)
#     Cookie based authentication
#     Interface for editing dhcp options/groups and hosts.
#     Synchronisation between hosts
#     Scalability improvements
#     Various code clean-ups
#     Consistency checker for host information 
#----------------------------------------------------------------------------/
use FindBin;
use lib "$FindBin::RealBin"; # locate library path for below modules.
use strict;
use warnings;

# Possible mod_perl support
use constant IS_MODPERL => $ENV{MOD_PERL};
use subs qw(exit);
# Select the correct exit function
*exit = IS_MODPERL ? \&Apache::exit : sub { CORE::exit };

use Variables qw( variables_init $IP $MAC );
use Html qw( html_init print_html_file get_input admin_error);
use Files_Remote qw (get_host_info_remote_all);
use Subnets;
use Authenticate;
use Database qw (db_connect);

#----------------------------------------------------------------------------\
# Main Function
#----------------------------------------------------------------------------\
variables_init();
html_init();

if (!db_connect()) {
    admin_error("Could not connect to Database","Database");
    print_html_file("register_footer.html");
}

#FAQ
my %FORM = get_input();
$FORM{'page'} && $FORM{'page'} =~ /faq/ && do {
                              print_html_file('register_header.html');
                              print_html_file('faq.html'); exit;};

# News
#my %FORM = get_input();
#$FORM{'page'} && $FORM{'page'} =~ /news/ && do {
#			      print_html_file('register_header.html');
#			      print_html_file('html/news.html'); exit;};

# fallback
my $mac = get_host_info_remote_all($ENV{'REMOTE_ADDR'}) || 'Unknown';
print_html_file('index.html',"\\^MAC",$mac);
#
# Mitchell Added
#my $ipaddr = get_host_info_remote_all($ENV{'REMOTE_ADDR'}) || 'Unknown';
#print_html_file('index.html',"\\^IPADDR",$ipaddr);
exit;
