#!/usr/bin/perl -w
#
#
# CLIENT TEST MODULE for the dhcpdmanager daemon 
# (this module is designed to test every function available, from dhcpdmanager,
#  while at the same time being a good example code sample for it's potential usage)
# For a simpler "connect/disconnect" type test script see "test_dhcpdmanager"
#
# By David Bussenschutt September 2002
#
use FindBin qw( $RealBin ) ;
use lib "$RealBin";
use DhcpdManager;

use Variables qw($KeyName $Key); # for the DHCP_UPDATER KeyName and Key below...


my $conn = DhcpdManager->new(
			base64 => 0,
			port => '7912',
			server => '132.234.10.1',
			omapi_key => $KeyName,
			omapi_secret => $Key,
			randlen => 40,
			base64 => 1,
			); # open TCPIP, with whatever options you like
die "couldn't connect to server" unless $conn;  # couldn't connect
$conn->send("CONNECT");  # send initial CONNECT, to initiate server response
die "security handshake failed with server" unless $conn->auth();  # handshake with the server

# TEST THE SERVER!
  do { 

#and here is a collection of commands the server understands...

          $conn->send("list server subnets");
          print join "\n",$conn->read_data(); print "\n";

          $conn->send("list subnet pools");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list subnet pools in 132.234.250.0");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list subnet pools in 255.255.255.0");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list leases");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list leases in 132.234.28.0/24");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list leases in 132.234.250.0/24");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("list hosts");
          print join "\n",$conn->read_data(); print "\n";
 
          $conn->send("return pool client state for 132.234.250.250");
          print $conn->recv(),"\n";
 
          $conn->send("return pool client state for 132.234.250.20");
          print $conn->recv(),"\n";

          $conn->send("return mac address for 132.234.250.250");
          print "MAC:",$conn->recv(),"\n";
          
	  $conn->send("return mac address for 132.234.250.201");
          print "MAC:",$conn->recv(),"\n";

          $conn->send("add host testdhcpd { hardware ethernet 00:01:02:03:04:05 ; }#Mozzy/9.9 (uncompatible; BUZ 1.23; WinDoze NUT 0.1)#20020911 15:41:53#132.234.250.249");
          print $conn->recv(),"\n";

          $conn->send("add host testdhcpd dskflsdklfsdf dslfk sdkfljdslkfslkjfsd");
          print $conn->recv(),"\n";

          $conn->send("delete host with mac of 00:01:02:03:04:05");
          print $conn->recv(),"\n";

          $conn->send("delete host with mac of 00:01:02:03:04:05");
          print $conn->recv(),"\n";

          $conn->send("return dhcpd server status");
          print $conn->recv(),"\n";

          $conn->send("list hosts");
          print join "\n",$conn->read_data(); print "\n";

	  $conn->send("add subclass \"match-hardware\" 1:00:60:08:C9:91:99 { ddns-hostname \"blah2\"; option domain-name \"az.gu.edu.au\"; }");
          print $conn->recv(),"\n";

	  $conn->send("list subclasses");
          print $conn->recv(),"\n";

          $conn->send("delete host with mac of 00:60:08:C9:91:99");
          print $conn->recv(),"\n";


    } while (0);   # test the server once...
#    } while (1);    # test the server forever, till a ctrl-c

exit; # exits above..., this line is unreachable!


#---------------------------------
